#!/usr/bin/perl

#y $router = '10.1.1.1:80,443,8080|10.1.1.2:80,443,8080|10.1.1.3:80,443,8080|';
my $router = '91.202.25.220:80,443,8080|';
my $log = '/tmp/rl.ammyy.com.log';
my $CMD;

use strict;

my $IP = $ENV{'REMOTE_ADDR'};
my $CL = $ENV{'CONTENT_LENGTH'};
my $RM = $ENV{'REQUEST_METHOD'};
my $QS = '';
if($RM eq 'POST') {read(STDIN, $QS, $CL);} else {$QS = $ENV{'QUERY_STRING'};}


#######################################################

sub logg
{
open(LLL,">>$log");
print LLL @_, "\n";
close(LLL);
}

#######################################################



my $date=`date +"%T %d.%m.%Y"`; chop($date);
logg("---\n $date\t$IP");

#######################################################

if (!$QS)     # if NOT exist parameters
   {
   logg(" no parameters");
   print "Content-Type: text/html\n";
   print "Cache-control: no-cache\n";
   print "Pragma: no-cache\n";
   print "Connection: close\n\n";
   print "Page loaded OK\n";
   exit;
   }
      else
   {
   my $z;
   my $name; my $value;
   my $v; my $d;
   my @pairs = split(/&/, $QS);
   foreach $z (@pairs)
      {
      ($name, $value) = split(/=/,$z);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      if ($name eq 'v') {$v = $value}
      if ($name eq 'd') {$d = $value}
      }
#  if ($v eq '')
#     {
#     print "Content-Type: text/html\n";
#     print "Cache-control: no-cache\n";
#     print "Pragma: no-cache\n";
#     print "Connection: close\n\n";
#     print "version\n";
#     exit;
#     }
   if ($d eq '')
      {
      logg(" no d= parameter");
      print "Content-Type: text/html\n";
      print "Cache-control: no-cache\n";
      print "Pragma: no-cache\n";
      print "Connection: close\n\n";
      print "data\n";
      exit;
      }

   my $raw = &decode($d); # decode and set CMD
   my $rawtxt = $raw;
   $rawtxt =~ tr/\x00/\|/;
   $rawtxt =~ tr/\x01-\x1f/.............................../;

   my $hex = '';
   foreach my $i (0 .. length($raw)-1)
      {
      $hex .= unpack('H2',substr($raw,$i,1));
      $hex .= ' ';
      }
   chop $hex;


# CMD = 10, router button start
# Dec 12 2008 at 02:10:08|80,443,8080|0.0.0.0|

   if ($CMD == 10)
      {
      logg(" CMD 10 - run AMMYY_Router.exe and press Start button:\n $rawtxt");
      $z = "\x0A\x00\x00\x00\x00";
      $z = 'RL--' . &encode($z);
      print "Content-Type: text/html\n";
      print "Cache-control: no-cache\n";
      print "Pragma: no-cache\n";
      print "Connection: close\n";
      print "Content-Length: ",length($z),"\n\n";
      print $z;
      exit;
      }

# CMD = 6, run AMMYY_Admin.exe:
# Ammyy Admin|2.13|May 16 2010 at 19:11:24||1049|3156132|5.1.2600 0 SP3.0|1049.7.203|.||||...EX|||||.|||| <- WinXP
# Ammyy Admin|2.13|May 16 2010 at 19:11:24||1049||5.0.2195 -1 SP4.0|1049.7.-1|.||||...EX|||||.||||        <- W2k
# Ammyy Admin|2.13|May 16 2010 at 19:11:24||1049|---ERROR---|5.0.2195 -1 SP4.0|1049.7.-1|.||||...EX|||||.||||
# Ammyy Admin|3.0|Nov  8 2011 at 04:07:39||1049|3156132|5.1.2600 0 SP3.0|1049.7.203|.||||...EX.|.?.|||3.AAE|ST3200827AS|4ND2D0NA||.||||

   if ($CMD == 6)
      {
      logg(" CMD 6 - run AMMYY_Admin.exe:\n $rawtxt\n $hex");
      my $prg; my $vers; my $ID;

      $z = substr($rawtxt,4);
      ($prg,$vers,$ID) = (split('\|',$z))[0,1,5];
      if (($ID eq '') || ($ID =~ /ERROR/)) {$ID = time() - 1308000000}
      logg(" $prg,$vers,$ID");

      if ($prg ne 'Ammyy Admin')
         {
         logg(" no string 'Ammyy Admin'");
         print "Content-Type: text/html\n";
         print "Cache-control: no-cache\n";
         print "Pragma: no-cache\n";
         print "Connection: close\n\n";
         print "admin\n";
         exit;
         }
      if ($vers ne $v)
         {
         logg(" versions mismatch $vers != $v");
         print "Content-Type: text/html\n";
         print "Cache-control: no-cache\n";
         print "Pragma: no-cache\n";
         print "Connection: close\n\n";
         print "version2\n";
         exit;
         }
      if ($ID !~ /^\d+$/)
         {
         logg(" wrong id $ID");
         print "Content-Type: text/html\n";
         print "Cache-control: no-cache\n";
         print "Pragma: no-cache\n";
         print "Connection: close\n\n";
         print "id\n";
         exit;
         }
      $z = "\x06\x00\x00\x00\x00" . $ID . "\x00" . $router . "\x00\x00\x00";
      $z = 'RL--' . &encode($z);
      print "Content-Type: text/html\n";
      print "Cache-control: no-cache\n";
      print "Pragma: no-cache\n";
      print "Connection: close\n";
      print "Content-Length: ",length($z),"\n\n";
      print $z;
      exit;
      }

# CMD = 12, operator will connect to client:
# 2.13|May 16 2010 at 19:11:24|1049.7.203|1049|¤(0 №Ч0
#
#                       |N  O  T  _  F  O  U  N  D    |           |           |
# v3 answer: 0C 00 00 00 4E 4F 54 5F 46 4F 55 4E 44 00 00 00 30 00 00 00 00 01 2D 00

   if ($CMD == 12)
      {
      my $ID1 = unpack('L',substr($raw,length($raw)-8,4));
      my $ID2 = unpack('L',substr($raw,length($raw)-4,4));
      logg(" CMD 12 - operator will connect to client:\n $rawtxt\n $ID1 -> $ID2");
#     $z = "\x0C\x00\x00\x00\x00" . $IP   . ':443,80,8080' . "\x00\x00\x30\x00\x00\x00\x00\x01";
#     $z = "\x0C\x00\x00\x00\x00" . $IP   . ':443,80,8080' . "\x00\x00\x30\x00\x00\x00\x00\x01\x2d\x00";

      my $r = $router; chop $r if ($r =~ /\|$/) ;
      $z = "\x0C\x00\x00\x00\x00" . $r  . "\x00\x00\x30\x00\x00\x00\x00\x01\x2d\x00";
      $z = 'RL--' . &encode($z);
      print "Content-Type: text/html\n";
      print "Cache-control: no-cache\n";
      print "Pragma: no-cache\n";
      print "Connection: close\n";
      print "Content-Length: ",length($z),"\n\n";
      print $z;
      exit;
      }

# CMD = 14, operator V3 disconnect from client:
#       from operator v3:
# .|||.|..eRg..&fR..o..0..10.10.254.252|10.10.254.243|...|||||..||||||?.|||||
# 0e 00 00 00 03 00 ee ff 65 52 67 01 0a 26 66 52 db 7f 6f 04 e7 30 87 01 31 30 2e 31 30 2e 32 35 34 2e 32 35 32 00 31 30 2e 31 30 2e 32 35 34 2e 32 34 33 00 af ab 01 00 00 00 00 00 b9 0e 00 00 00 00 00 00 d3 ad 02 00 00 00 00 00
#       from router v3:
# .|||.Nov 14 2012 at 15:19:29|?Rg...fR?o.?.10.10.254.252|10.10.254.243|?|||||||:|||||||@9||||||
# 0e 00 00 00 02 4e 6f 76 20 31 34 20 32 30 31 32 20 61 74 20 31 35 3a 31 39 3a 32 39 00 ee ff 65 52 67 01 19 1d 66 52 db 7f 6f 04 e7 30 87 01 31 30 2e 31 30 2e 32 35 34 2e 32 35 32 00 31 30 2e 31 30 2e 32 35 34 2e 32 34 33 00 8a 00 00 00 00 00 00 00 3a 00 00 00 00 00 00 00 40 39 00 00 00 00 00 00
#       from v2:
# .|||.Nov 14 2012 at 15:19:29|.0fR(..1fR..o..0..10.10.254.252|10.10.254.243|.H.|||||..||||||f8||||||
# 0e 00 00 00 01 4e 6f 76 20 31 34 20 32 30 31 32 20 61 74 20 31 35 3a 31 39 3a 32 39 00 f5 30 66 52 28 01 07 31 66 52 db 7f 6f 04 e7 30 87 01 31 30 2e 31 30 2e 32 35 34 2e 32 35 32 00 31 30 2e 31 30 2e 32 35 34 2e 32 34 33 00 9e 48 01 00 00 00 00 00 ba 02 00 00 00 00 00 00 66 38 00 00 00 00 00 00

   if ($CMD == 14)
      {
      my $id1; my $id2;
      my $ip1; my $ip2;
      my $i;

      my $flag = unpack('C',substr($raw,4,1));          # ???

      if ($flag == 3)                                   # msg from operator v3
         {
         $i=5;
         }
      elsif ($flag == 2)                                # msg from router v3
         {
         $z = substr($rawtxt,5);
         $i = 5 + index($z,"|");
         }
      elsif ($flag == 1)                                # msg from v2
         {
         $z = substr($rawtxt,5);
         $i = 5 + index($z,"|");
         }
      else
         {
         logg(" CMD 14 - operator disconnect from client:\n $rawtxt\n $hex\n unknown code $flag");
         }

      $id2 = unpack('L',substr($raw,$i+11,4));
      $id1 = unpack('L',substr($raw,$i+15,4));

      my $tmp = substr($rawtxt,$i+19);

#         $i = index($tmp,"|"); my $ip2 = substr($tmp,0,$i-1);
#         $tmp = substr($tmp,$i+1);
#         $i = index($tmp,"|"); my $ip1 = substr($tmp,0,$i-1);

      ($ip2,$ip1) = split('\|',$tmp);
      logg(" CMD 14 - operator disconnect from client:\n $rawtxt\n $hex\n $id1 from $id2 ($ip1 from $ip2)");

      $z = "\x0E\x00\x00\x00\x00\x00";
      $z = 'RL--' . &encode($z);
      print "Content-Type: text/html\n";
      print "Cache-control: no-cache\n";
      print "Pragma: no-cache\n";
      print "Connection: close\n";
      print "Content-Length: ",length($z),"\n\n";
      print $z;
      exit;
      }

# CMD = 8, router send to rl.ammyy.com info about connected client(s)
#            |   length  |    ip     |   length  |    id     |
# 08 00 00 00 04 00 00 00 0A 01 01 4E 04 00 00 00 B9 D7 09 00                   v2
#                        |   lenght  |    id1    |    id2    |
# 08 00 00 00 00 00 00 00 08 00 00 00 e7 30 87 01 db 7f 6f 04                   v3

   if ($CMD == 8)
      {
      my $flag = unpack('L',substr($raw,4,4));          # ???

      if ($flag != 0)                                   # v2
         {
         $z = substr($raw,8);
         my $txt = '';
         while (length($z) > 0)
            {
            my $ip = '';
            my $id = '';

            $ip .= unpack('C',substr($z,0,1)) . '.';
            $ip .= unpack('C',substr($z,1,1)) . '.';
            $ip .= unpack('C',substr($z,2,1)) . '.';
            $ip .= unpack('C',substr($z,3,1));
            $z  =  substr($z,8);
            $id =  unpack('L',substr($z,0,4));
            $z  =  substr($z,4);
            $txt .= "  ip $ip id $id\n";
            }
         chop $txt;

         logg(" CMD 8 (v2) - router send info 'connected client(s)':\n $hex\n$txt");
         }
            else                                      # v3
         {
         $z = substr($raw,8);
         my $txt = '';
         my $len = unpack('L',substr($z,0,4));
         $z = substr($z,4);
         while (length($z) > 0)
            {
            my $id = '';
            $id =  unpack('L',substr($z,0,4));
            $z  =  substr($z,4);
            $txt .= "  id $id\n";
            }
         chop $txt;

         logg(" CMD 8 (v3) - router send info 'connected client(s)':\n $hex\n$txt");
         }

      $z = "\x08\x00\x00\x00";
      $z = 'RL--' . &encode($z);
      print "Content-Type: text/html\n";
      print "Cache-control: no-cache\n";
      print "Pragma: no-cache\n";
      print "Connection: close\n";
      print "Content-Length: ",length($z),"\n\n";
      print $z;
      exit;
      }

# CMD = 7, router send to rl.ammyy.com info about traffic
# Dec 12 2008 at 02:10:08|20110621-10:24:33.562 41891 3070 26340 v 10.3.60.1 8465 80 3156132 10.3.50.200 56580 80 645049|

   if ($CMD == 7)
      {
      logg(" CMD 7 - router send info about traff:\n $rawtxt");
      $z = "\x07\x00\x00\x00\x00\x00";
      $z = 'RL--' . &encode($z);
      print "Content-Type: text/html\n";
      print "Cache-control: no-cache\n";
      print "Pragma: no-cache\n";
      print "Connection: close\n";
      print "Content-Length: ",length($z),"\n\n";
      print $z;
      exit;
      }

# Unknown CMD
#

   logg(" Unknown CMD $CMD");
   print "Content-Type: text/html\n";
   print "Cache-control: no-cache\n";
   print "Pragma: no-cache\n";
   print "Connection: close\n";
   print "Content-Length: 26\n\n";
   print 'ERROR in RLStream.GetDWORD';
   exit;
   }

######################################################################
######################################################################
######################################################################
######################################################################

sub decode()
{
my $buffer = shift;
my $dest = '';

my $shifr = "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # 00
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # 10
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\x3F\xFF\x3E" . # 20
            "\x3A\x08\x09\x0A\x0B\x0C\x0D\x3B\x3C\x3D\xFF\xFF\xFF\xFF\xFF\xFF" . # 30
            "\xFF\x24\x25\x26\x27\x00\x01\x02\x03\x04\x05\x06\x07\x0E\x0F\x10" . # 40
            "\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1A\x1B\xFF\xFF\xFF\xFF\xFF" . # 50
            "\xFF\x1C\x1D\x1E\x1F\x20\x21\x22\x23\x28\x29\x2A\x2B\x2C\x2D\x2E" . # 60
            "\x2F\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\xFF\xFF\xFF\xFF\xFF" . # 70
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # 80
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # 90
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # A0
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # B0
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # C0
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # D0
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" . # E0
            "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF";  # F0


my $arg_0 = 0;
my $arg_4 = 0;
my $edi = 0;
my $al;
my $cl;
my $ecx;
my $eax;

loc_417063:

do {
   $al = unpack('C',substr($buffer,$edi,1));
   $edi++;
   $eax = unpack('C',substr($shifr,$al,1));
   $ecx = $arg_4;
   $arg_0 += 6;
   $ecx = (($ecx << 6) | $eax);
   $arg_4 = $ecx;
   if ($arg_0 >= 8)
      {
      $arg_0 -= 8;
      $eax = $ecx;
      $ecx = $arg_0;
      $cl = $ecx & 0xFF;
      $eax = $eax >> $cl;
      $al = $eax & 0xFF;
      $dest .= pack('C',$al);
      }
   } until ($edi >= length($buffer));

# open(DCD,">/tmp/decode.bin"); binmode DCD; print DCD $dest; close(DCD);

$CMD = unpack('C',substr($dest,0,1)); # command for rl.ammyy.com

return $dest;
}

######################################################################

sub encode()
{
my $buffer = shift;
my $dest = '';

my $shifr = 'EFGHIJKL123456MNOPQRSTUVWXYZabcdefghABCDijklmnopqrstuvwxyz0789/-';


my $edi = 0;
my $arg_4 = 0;
my $ecx = 0;
my $arg_0 = 0;
my $eax;
my $al;
my $cl;

loc_416F22:

do {
   $eax = unpack('C',substr($buffer,$arg_4,1));
   $arg_4++;
   $edi = ($edi << 8) + $eax;
   $arg_0 += 8;
   do {
      $arg_0 -= 6;
      if ($arg_0 == 0)
         {
         $ecx = $edi;
         $edi = 0;
         }
      if ($arg_0 == 2)
         {
         $ecx = $edi;
         $ecx = $ecx >> 2;
         $edi = $edi & 3;
         }
      if ($arg_0 == 4)
         {
         $ecx = $edi;
         $ecx = $ecx >> 4;
         $edi = $edi & 0x0F;
         }
      if ($arg_0 == 6)
         {
         $ecx = $edi;
         $ecx = $ecx >> 6;
         $edi = $edi & 0x3F;
         }
      $al = substr($shifr,$ecx,1);
      $dest .= $al;
      } until ($arg_0 < 6);
   } until ($arg_4 >= length($buffer));

if ($arg_0 > 0)
   {
   $ecx = 6 - $arg_0;
   $cl = $ecx & 0xFF;
   $edi = $edi << $cl;
   $al = substr($shifr,$edi,1);
   $dest .= $al;
   }

return $dest;
}

######################################################################

1;
